#include "SharedData.h"

//
// XbhԂŋLf[^
//
DataPoint data_point;      // f[^
ModelPoint model_point;    // ff[^i[p
ResultData result_data;    // }b`Of̏dSʒu
DataFromRTC data_from_rtc; // RTC瑗Ăwʒuf[^

template<class T>
void clear_array_(T *ary, T val, unsigned int size)
{
	for (unsigned int i = 0; i < size; ++i) {
		ary[i] = val;
	}
}

SharedObject::SharedObject()
{
}

SharedObject::~SharedObject()
{
}

void SharedObject::lock()
{
	this->lock_.lock();
}

void SharedObject::unlock()
{
	this->lock_.unlock();
}

DataPoint::DataPoint()
: SharedObject()
{
	clear();
}

DataPoint::~DataPoint()
{
}

void DataPoint::clear()
{
	num = 0;
	clear_array_(x, 0.0f, MAX_DATA_NUM);
	clear_array_(y, 0.0f, MAX_DATA_NUM);
	clear_array_(z, 0.0f, MAX_DATA_NUM);
}

ModelPoint::ModelPoint()
: SharedObject()
{
	clear();
}

ModelPoint::~ModelPoint()
{
}

void ModelPoint::clear()
{
	num = 0;
	clear_array_(x, 0.0f, MAX_MODEL_NUM);
	clear_array_(y, 0.0f, MAX_MODEL_NUM);
	clear_array_(z, 0.0f, MAX_MODEL_NUM);
	clear_array_(gravi, 0.0f, 3);
	for (unsigned int i = 0; i < 3; ++i) {
		clear_array_(ref_point[i], 0.0f, 3);
	}
}

ResultData::ResultData()
: SharedObject()
{
	clear();
}

ResultData::~ResultData()
{
}

void ResultData::clear()
{
	clear_array_(result, 0.0f, 20);
}

DataFromRTC::DataFromRTC()
{
	clear();
}

DataFromRTC::~DataFromRTC()
{
}

void DataFromRTC::clear()
{
	num = 0;
	clear_array_(d1, 0.0f, MAX_DATA_NUM);
	clear_array_(d2, 0.0f, MAX_DATA_NUM);
	clear_array_(d3, 0.0f, MAX_DATA_NUM);
}
