// -*-C++-*-
/*!
 * @file  TactileServiceSVC_impl.h
 * @brief Service implementation header of TactileService.idl
 *
 */

#include "TactileServiceSkel.h"

#ifndef TACTILESERVICESVC_IMPL_H
#define TACTILESERVICESVC_IMPL_H
 
/*
 * Example class implementing IDL interface TactileService
 */
class TactileServiceSVC_impl
 : public virtual POA_TactileService,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~TactileServiceSVC_impl();

 public:
   // standard constructor
   TactileServiceSVC_impl(long *ModelID);
   virtual ~TactileServiceSVC_impl();

   // attributes and operations
   CORBA::Long getModelID();
   void setModelID(CORBA::Long ModelID);
 private:
   long *m_ModelID;

};



#endif // TACTILESERVICESVC_IMPL_H


